#Dans Terminal
#jupyter lab
#python tp5_exo2.py
#


import matplotlib.pyplot as plt
import numpy as np







def orthonorm(Y):
    n,m=Y.shape
    if n<m:
        print('Dimensions incompatibles')
    Z=np.zeros((n,m))
    u=Y[0:,0]
    u=u/np.linalg.norm(u)
    Z[0:,0]=u
    for j in range(1,m):
        u=Y[0:,j]
        W=np.dot(Z,Z.T)
        u=u-np.dot(W,u)
        u=u/np.linalg.norm(u)
        Z[0:,j]=u
    return Z        

def householder(a):
    # retourne le vecteur de Householder de norme 1
    n=len(a)
    alpha=np.linalg.norm(a)
    if np.linalg.norm(a[1:])< 10**(-6):
        return a/alpha
    else:
        v=a.copy()
        v[0]=v[0]-alpha
        v=v/np.linalg.norm(v)
        return v
        
        
    
    

def QR(A):
    # renvoie  dans l'ordre Q,R tq A=QR
    n,m=A.shape
    s=min(n,m)
    R=A.copy()
    H=np.eye(n)
    for k in range(s-1):
        u=householder(R[k:,k])
        u.shape=(n-k,1)
        H1=np.eye(n)
        H1[k:,k:]=np.eye(n-k)-2*np.dot(u,u.T) #tH1
        R=np.dot(H1,R)   #np.zeros((n,m))
        H=np.dot(H1,H)
    Q=H.T
    return Q,R




# Exercice 2

Y=np.random.rand(4,4)
Z=orthonorm(Y)
print('Y=', Y)
print('Z=', Z)
test1=abs(np.linalg.matrix_rank(Z)-np.linalg.matrix_rank(Y))
print('Erreur sur le rang: ',test1)

A=np.random.rand(4,4)

u=householder(A[0:,0])
u.shape=(4,1)
H1=np.eye(4,4)-2*np.dot(u,u.T)
B=np.dot(H1,A)
print('B=',B)

u=householder(B[1:,1])
u.shape=(3,1)
#H22=np.eye(3,3)-2*np.dot(u,u.T)
H2=np.eye(4,4)
H2[1:,1:]=np.eye(3,3)-2*np.dot(u,u.T)
C=np.dot(H2,B)
print('C=',C)

u=householder(C[2:,2])
u.shape=(2,1)
#H33=np.eye(2,2)-2*np.dot(u,u.T)
H3=np.eye(4,4)
H3[2:,2:]=np.eye(2,2)-2*np.dot(u,u.T)
D=np.dot(H3,C)
print('D=',D)

H=np.dot(H3,np.dot(H2,H1))
Q=H.T
E=np.dot(Q,D)
verif=np.linalg.norm(E-A)


E=np.dot(Q.T,Q)
verif=verif+np.linalg.norm(E-np.eye(4,4))


E=np.dot(Q,Q.T)
verif=verif+np.linalg.norm(E-np.eye(4,4))
print('erreur=',verif)

Q1,R1=QR(A)
verif=np.linalg.norm(Q-Q1)+np.linalg.norm(D-R1)
print('comparaison=',verif)

A=np.random.rand(20,15)
Z=orthonorm(A)
Q,R=QR(A)
verif=np.linalg.norm(Z-Q[0:,0:15])
print('comparaison des méthodes=',verif)
verif=np.linalg.norm(A-np.dot(Q,R))
print('erreur QR=',verif)