#Dans Terminal
#jupyter lab
#python tp5_exo3.py
#


import matplotlib.pyplot as plt
import numpy as np

def orthonorm(Y):
    n,m=Y.shape
    if n<m:
        print('Dimensions incompatibles')
    Z=np.zeros((n,m))
    u=Y[0:,0]
    u=u/np.linalg.norm(u)
    Z[0:,0]=u
    for j in range(1,m):
        u=Y[0:,j]
        #u.shape=(n,1)
        W=np.dot(Z,Z.T)
        u=u-np.dot(W,u)
        u=u/np.linalg.norm(u)
        Z[0:,j]=u
    return Z        



def puissk(a,m):
    if m==1:
        return a
    else:
        return np.dot(puissk(a,m-1),a)


def fact(n):
    if n==0:
        return 1
    else:
        return fact(n-1)*n



def expm(a,m):
    u,v=np.shape(a)
    if m==0:
        return np.eye(u)
    else:
        ak=puissk(a,m)/fact(m)
        return(expm(a,m-1)+ak)
    
    
def puissance(A,N,m):
    #A0=A.copy()
    n=len(A[0])
    x0=2*np.random.rand(n,m)
    x0=x0-np.ones((n,m))
    #x=x0.copy()
    for k in range(N):
        y=np.dot(A,x0)
        nu=np.dot(x0.T,y)
        x0=orthonorm(y)
    return x0,nu    

def puissance_eps(A,m):
    eps=10**(-6)
    itmax=500
    #A0=A.copy()
    n=len(A[0])
    x0=2*np.random.rand(n,m)
    x0=x0-np.ones((n,m))
    #x=x0.copy()
    test=1
    tabtest=np.zeros(itmax+1)
    tabnu=np.zeros(itmax+1)
    it=0
    nu1=np.zeros((m,m))
    while test > eps and it < itmax:
        y=np.dot(A,x0)
        nu=np.dot(x0.T,y)
        x0=orthonorm(y)
        test=np.linalg.norm(nu-nu1)
        tabtest[it]=test
        tabnu[it]=max(abs(np.diag(nu)))
        nu1=nu.copy()
        it+=1
    taberr=tabtest[:it+1]
    tabnu0=tabnu[1:it]                   
    return tabnu0,taberr,x0,nu,it    



N=20

n=5

J=np.tril(np.ones((n,n)))
J=(J-J.T)/2
U=expm(J,100)
A=np.dot(np.dot(U,np.diag(100*0.9**(np.arange(1,n+1)))),U.T)

x0,nu0=puissance(A,N,m=1)

print('nu0=',nu0)




#
A0=np.diag([-2,1,1])
x0,nu0=puissance(A0,N,m=1)

print('nu0=',np.diag(nu0))

#
A0=np.diag([-2,-2,1])
x0,nu0=puissance(A0,N,m=1)

print('nu0=',np.diag(nu0))


#
A0=np.array([[2,1,0],[0,2,0],[0,0,1]])
x0,nu0=puissance(A0,N,m=1)

print('nu0=',np.diag(nu0))

#
A0=np.array([[2,0,0],[0,1,1],[0,0,1]])
x0,nu0=puissance(A0,N,m=1)

print('nu0=',np.diag(nu0))


##
N=100 #20 #50 #20

n=40
J=np.tril(np.ones((n,n)))
J=(J-J.T)/2
U=expm(J,100)
A=np.dot(np.dot(U,np.diag(100*0.9**(np.arange(1,n+1)))),U.T)

x0,nu0=puissance(A,N,m=1)
print('nu0=',nu0)


tabnu0,taberr,x0,nu0,it=puissance_eps(A,m=1)
print('converge au bout de',it,'iterations')
print('nu0=',max(abs(np.diag(nu0))))


x0,nu0=puissance(A,N,m=2)
print('nu0=',nu0)

tabnu0,taberr,x0,nu0,it=puissance_eps(A,m=2)
print('converge au bout de',it,'iterations')
print('nu0=',max(abs(np.diag(nu0))))


x0,nu0=puissance(A,N,m=5)
print('nu0=',nu0)

tabnu0,taberr,x0,nu0,it=puissance_eps(A,m=5)
print('converge au bout de',it,'iterations')
print('nu0=',max(abs(np.diag(nu0))))

plt.plot(tabnu0)                    
plt.title('Evolution de la valeur propre maximale')
plt.show()

