#Dans Terminal
#jupyter lab
#python tp5_exo4.py
#


import matplotlib.pyplot as plt
import numpy as np


def puissk(a,m):
    if m==1:
        return a
    else:
        return np.dot(puissk(a,m-1),a)


def fact(n):
    if n==0:
        return 1
    else:
        return fact(n-1)*n



def expm(a,m):
    u,v=np.shape(a)
    if m==0:
        return np.eye(u)
    else:
        ak=puissk(a,m)/fact(m)
        return(expm(a,m-1)+ak)
    
def householder(a):
    # retourne le vecteur de Householder de norme 1
    n=len(a)
    alpha=np.linalg.norm(a)
    if np.linalg.norm(a[1:])< 10**(-6):
        return a/alpha
    else:
        v=a.copy()
        v[0]=v[0]-alpha
        v=v/np.linalg.norm(v)
        return v
        

def QR(A):
    # renvoie  dans l'ordre Q,R tq A=QR
    n,m=A.shape
    s=min(n,m)
    R=A.copy()
    H=np.eye(n)
    for k in range(s-1):
        u=householder(R[k:,k])
        u.shape=(n-k,1)
        H1=np.eye(n)
        H1[k:,k:]=np.eye(n-k)-2*np.dot(u,u.T) #tH1
        R=np.dot(H1,R)   #np.zeros((n,m))
        H=np.dot(H1,H)
    Q=H.T
    return Q,R


    
    
    
def QRval(A,it):
    # retourne dans l'ordre Q,R,taberr
    A0=A.copy()
    n,m=A.shape
    if n != m:
        raise ValueError('Dimensions incompatibles')
    Q=np.eye(n)
    taberr=np.zeros(it)
    for k in range(it):
        Qk,Rk=QR(A0)
        A0=np.dot(Rk,Qk)
        Q=np.dot(Q,Qk)
        taberr[k]=np.linalg.norm(A0-np.triu(A0))
    return Q,A0,taberr    # --> Q,R,taberr

    
def QRval_eps(A,eps):
    # retourne dans l'ordre Q,R,taberr
    A0=A.copy()
    n,m=A.shape
    if n != m:
        raise ValueError('Dimensions incompatibles')
    Q=np.eye(n)
    itmax=100
    taberr=np.zeros(itmax+1)
    it=0
    test=np.linalg.norm(A0-np.triu(A0))
    taberr[0]=test
    while test > eps and it < itmax:
        it += 1
        Qk,Rk=QR(A0)
        A0=np.dot(Rk,Qk)
        #A0=A1.copy()
        Q=np.dot(Q,Qk)
        test=np.linalg.norm(A0-np.triu(A0))
        taberr[it]=test
        #it += 1
    tabtest=taberr[:it+1]
    return Q,A0,tabtest,it    # --> Q,R,taberr,it




it=100
n=40
J=np.tril(np.ones((n,n)))
J=(J-J.T)/2
U=expm(J,100)
A=np.dot(U,np.dot(np.diag(100*0.9**(np.arange(1,n+1))),U.T))
Q,R,taberr=QRval(A,it)
print('erreur de triangularisation=',taberr[-1])


taberrf=taberr[10:]
taberrf=np.log(taberrf)
tabiter=np.arange(it)
tabiterf=tabiter[10:]
#tabiterf=np.log(tabiterf)
print('dimension de tabiterf=',tabiterf.shape)
print('dimension de taberrf=',taberrf.shape)

pente=[(taberrf[i+1]-taberrf[i])/(tabiterf[i+1]-tabiterf[i]) for i in range(len(taberrf)-1)]
print('min de la pente=',min(pente),'max de la pente=',max(pente))

vec_ratio=np.polyfit(tabiterf,taberrf,1)
ratio=vec_ratio[0]
print('pente=',ratio)

verif=np.linalg.norm(100*0.9**(np.arange(1,n+1))-np.diag(R).T)
print('erreur=',verif)
plt.plot(tabiterf,taberrf)
plt.show()

#
eps=10**(-3)
Q,R,taberr,it=QRval_eps(A,eps)
print('erreur=',taberr[it])

taberrf=taberr[10:]
taberrf=np.log(taberrf)
tabiter=np.arange(it+1)
tabiterf=tabiter[10:]
#tabiterf=np.log(tabiterf)
pente=[(taberrf[i+1]-taberrf[i])/(tabiterf[i+1]-tabiterf[i]) for i in range(len(taberrf)-1)]
print('min de la pente=',min(pente),'max de la pente=',max(pente))

vec_ratio=np.polyfit(tabiterf,taberrf,1)
ratio=vec_ratio[0]
print('pente=',ratio)

verif=np.linalg.norm(100*0.9**(np.arange(1,n+1))-np.diag(R).T)
print('erreur=',verif)
plt.plot(tabiterf,taberrf)
plt.show()
